/*  Streaming functions for the BMP180 environment sensor.

    Copyright (C) 2019 Wolfgang Reissenberger <sterne-jaeger@openfuture.de>

    This application is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
*/

#include "Adafruit_BMP085.h"
Adafruit_BMP085 bmp;
struct {
  bool status;
  float temperature;
  float pressure;
} bmpData;


void updateBMP() {
  if (bmpData.status || (bmpData.status = bmp.begin())) {
    bmpData.temperature = bmp.readTemperature();
    bmpData.pressure    = bmp.readPressure() / 100.0;
  }
}

void serializeBMP(JsonObject &doc) {

  JsonObject data = doc.createNestedObject("BMP180");
  data["init"] = bmpData.status;

  if (bmpData.status) {
    data["Temp"] = bmpData.temperature;
    data["Pres"] = bmpData.pressure;
  }
}

String displayBMPParameters() {
  if (bmpData.status == false) return "";

  return " Temp: " + String(bmpData.temperature, 1) + "\n Pres: " + String(bmpData.pressure, 1) + "\n";
}
